#include "Common.h"

EXTERNAL Center(unsigned int sDim, unsigned int wDim)
{
	return (unsigned int) (sDim - wDim) / 2;
}

EXTERNAL ResizeHeight(HWND hWnd)
{
	HDC hdc;
	TEXTMETRIC tm;
	RECT rc;

	hdc = GetDC(hWnd);
	GetTextMetrics(hdc, &tm);
	ReleaseDC(hWnd, hdc);

	if (GetWindowLong(hWnd, GWL_EXSTYLE) & WS_EX_OVERLAPPEDWINDOW)
		tm.tmHeight += GetSystemMetrics(SM_CYEDGE) / 2;

	if (GetWindowLong(hWnd, GWL_STYLE) & WS_BORDER)
		tm.tmHeight += GetSystemMetrics(SM_CYBORDER) / 2;

	GetWindowRect(hWnd, &rc);
	SetWindowPos(hWnd, 0, 0, 0, rc.right - rc.left, tm.tmHeight, SWP_NOZORDER | SWP_NOMOVE);
}

EXTERNAL GetLastErrorMsg (char * Title)
{
	LPTSTR lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL);
	MessageBox( NULL, lpMsgBuf, Title, MB_OK | MB_ICONINFORMATION );
	LocalFree( lpMsgBuf );
}

EXTERNAL MsgDD(ULONG value)
{
	char String[33];
	_ultoa(value, String, 10);
	MessageBox(NULL, String, "MsgDD", NULL);
}

EXTERNAL Autosize(HWND hWnd)
{
//	char String[50]; // Used for 'small' strings, but 'unacceptable' for 'dynamic' strings?
	SIZE StringSize;
//char dcFontName[50];

	ULONG StringWithoutZeroSize = SendMessage(hWnd, WM_GETTEXTLENGTH, NULL, NULL);
	void * hAlloc = ALLOC(StringWithoutZeroSize + 1); //Alloc(StringWithoutZeroSize + 1);
	SendMessage(hWnd, WM_GETTEXT, StringWithoutZeroSize, (long) hAlloc);
//	SendMessage(hWnd, WM_GETTEXT, StringWithoutZeroSize, (long) &String);

	HDC hdc = GetDC(hWnd);
	
//GetTextFace(hdc, 50, &dcFontName[0]);
//MessageBox(NULL, dcFontName, "GetTextFace", NULL);

//	HFONT hSysFont = (HFONT) GetStockObject(SYSTEM_FONT);
//	HFONT hFont = (HFONT) SelectObject(hdc, frmMain.hComicSansMS);
	HFONT hDCFont = (HFONT) SelectObject(hdc, (HFONT) SendMessage(hWnd, WM_GETFONT, NULL, NULL));

	if (GetTextExtentPoint32(hdc, (char *) hAlloc, StringWithoutZeroSize, &StringSize) == NULL)
		GetLastErrorMsg("GetTextExtentPoint32 Error");
//	GetTextExtentPoint32(hdc, (char *) String, StringWithoutZeroSize, &StringSize);
	Free(hAlloc);

//MsgDD((ULONG) StringSize.cx);
//MessageBox(NULL, String, "MsgDD", NULL);

	SelectObject(hdc, hDCFont);
	ReleaseDC(hWnd, hdc);

	if (GetWindowLong(hWnd, GWL_EXSTYLE) & WS_EX_OVERLAPPEDWINDOW)
	{
		StringSize.cx += GetSystemMetrics(SM_CXEDGE) / 2;
		StringSize.cy += GetSystemMetrics(SM_CYEDGE) / 2;
	}

	if (GetWindowLong(hWnd, GWL_STYLE) & WS_BORDER)
	{
		StringSize.cx += GetSystemMetrics(SM_CXBORDER) / 2;
		StringSize.cy += GetSystemMetrics(SM_CYBORDER) / 2;
	}

	SetWindowPos(hWnd, 0, 0, 0, StringSize.cx, StringSize.cy, SWP_NOZORDER | SWP_NOMOVE);
}

void * Alloc (ULONG Size)
{
	static char * szHeapAllocErrorTitle = "HeapAlloc Error";
	static char * szHeapAllocSTATUS_NO_MEMORY = "The allocation attempt failed because of a lack of available memory or heap corruption.";
	static char * szHeapAllocSTATUS_ACCESS_VIOLATION = "The allocation attempt failed because of heap corruption or improper function parameters.";
	//void * hAlloc = HeapAlloc(App.Heap, HEAP_GENERATE_EXCEPTIONS | HEAP_ZERO_MEMORY, Size);
	void * hAlloc = HeapAlloc(GetModuleHandle(NULL), HEAP_GENERATE_EXCEPTIONS | HEAP_ZERO_MEMORY, Size);
	if (hAlloc == (void *) STATUS_NO_MEMORY)
		MessageBox(NULL, szHeapAllocSTATUS_NO_MEMORY, szHeapAllocErrorTitle, MB_OK | MB_ICONERROR);
	else if (hAlloc == (void *) STATUS_ACCESS_VIOLATION)
		MessageBox(NULL, szHeapAllocSTATUS_ACCESS_VIOLATION, szHeapAllocErrorTitle, MB_OK | MB_ICONERROR);
	return hAlloc;
}

void Free(void * FreeAddr)
{
	if (HeapFree(GetModuleHandle(NULL), NULL, FreeAddr) == NULL)
		GetLastErrorMsg("HeapFree Error");
}
